/*
 * Chapter 21
 * Task 2: Simulate time-consuming function
 *
 * The 3 LEDs connected to PA0,1,2 pins show a 3 digit counter
 * With pushbuttons connected to PD2 and PD3 the value can be incremented or decremented
 */

#include "../Headers/main.h"

//Declare a 32bit variable
uint32_t i;

volatile uint8_t cntr = 0;

int main(void)
{
    //Initializing IO ports
    IOInit();

    //Infinite loop
    while (1)
    {
	    //If button on PD2 is pushed AND counter is smaller than 7 (maximum)
	    if (!(PIND & 0x04) && (cntr < 7))
	    {
		    //Increment counter
		    cntr++;
	    }
	    //If button on PD3 is pushed AND counter is larger than 0 (minimum)
	    else if (!(PIND &  0x08) && (cntr > 0))
	    {
		    //Decrement counter
		    cntr--;
	    }
	    //Set LED states connected to PA0,1,2 to be equal with counter
	    PORTA = cntr;
		
		//Simulate time-consuming function in the infinite loop
		for (i=0; i<500000; i++)
		{
			
		}
    }

    return (0);
}